if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[at_AllTrades]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[at_AllTrades]
GO

CREATE TABLE [dbo].[at_AllTrades] (
	[ETC_SECBOARD] [varchar] (4) NULL ,
	[ETC_SECCODE] [varchar] (12) NULL ,
	[ETC_PRICE] [float] NULL ,
	[ETC_QUANTITY] [numeric](10, 0) NULL ,
	[ETC_VALUE] [float] NULL ,
	[ETC_TRADENO] [numeric](10, 0) NOT NULL ,
	[ETC_TRADETIME] [varchar] (8) NULL,
	[ETC_ACCRUEDINT] [float] NULL,
	[ETC_YIELD] [float] NULL,
	[ETC_PERIOD] [varchar] (1) NULL,
	[ETC_SETTLECODE] [varchar] (12) NULL,
	[ETC_BUYSELL] [varchar] (1) NULL,
	[ETC_REPORATE] [float] NULL,
	[ETC_REPOVALUE] [float] NULL,
	[ETC_REPO2VALUE] [float] NULL,
	[ETC_REPOTERM] [numeric] (8, 0) NULL
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[at_AllTrades] ADD 
	CONSTRAINT [PK_at_AllTrades] PRIMARY KEY  CLUSTERED 
	(
		[ETC_TRADENO]
	)  ON [PRIMARY] 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_atAllTrades]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_atAllTrades]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE  PROCEDURE sp_atAllTrades
@ETC_SECBOARD varchar (4) = NULL,
@ETC_SECCODE varchar (12) = NULL,
@ETC_PRICE float = NULL,
@ETC_QUANTITY numeric (10, 0) = NULL,
@ETC_VALUE float = NULL,
@ETC_TRADENO numeric (10, 0) = NULL,
@ETC_TRADETIME varchar (8) = NULL,

@ETC_ACCRUEDINT float = NULL,
@ETC_YIELD float = NULL,
@ETC_PERIOD varchar (1) = NULL,
@ETC_SETTLECODE varchar (12) = NULL,
@ETC_BUYSELL varchar (1) = NULL,
@ETC_REPORATE float = NULL,
@ETC_REPOVALUE float = NULL,
@ETC_REPO2VALUE float = NULL,
@ETC_REPOTERM numeric (8, 0) = NULL
AS

IF @ETC_TRADENO = NULL OR @ETC_TRADENO = 0
	RETURN

if not exists (select * from dbo.sysobjects where id = object_id (N'[dbo].[at_AllTrades]') and OBJECTPROPERTY (id, N'IsUserTable') = 1)
	RETURN

IF EXISTS (SELECT * FROM at_AllTrades WHERE ETC_TRADENO = @ETC_TRADENO)
	UPDATE at_AllTrades SET
		ETC_SECBOARD = @ETC_SECBOARD,
		ETC_SECCODE = @ETC_SECCODE,
		ETC_PRICE = @ETC_PRICE,
		ETC_QUANTITY = @ETC_QUANTITY,
		ETC_VALUE = @ETC_VALUE,
		ETC_TRADETIME = @ETC_TRADETIME,
    ETC_ACCRUEDINT = @ETC_ACCRUEDINT,
		ETC_YIELD = @ETC_YIELD,
		ETC_PERIOD = @ETC_PERIOD,
		ETC_SETTLECODE = @ETC_SETTLECODE,
		ETC_BUYSELL = @ETC_BUYSELL,
		ETC_REPORATE = @ETC_REPORATE,
		ETC_REPOVALUE = @ETC_REPOVALUE,
		ETC_REPO2VALUE = @ETC_REPO2VALUE,
		ETC_REPOTERM = @ETC_REPOTERM
	WHERE ETC_TRADENO = @ETC_TRADENO
ELSE
	INSERT INTO at_AllTrades
	 (
		ETC_SECBOARD,
		ETC_SECCODE,
		ETC_PRICE,
		ETC_QUANTITY,
		ETC_VALUE,
		ETC_TRADENO,
		ETC_TRADETIME,
		ETC_ACCRUEDINT,
		ETC_YIELD,
		ETC_PERIOD,
		ETC_SETTLECODE,
		ETC_BUYSELL,
		ETC_REPORATE,
		ETC_REPOVALUE,
		ETC_REPO2VALUE,
		ETC_REPOTERM
	)
	VALUES
	 (
		@ETC_SECBOARD,
		@ETC_SECCODE,
		@ETC_PRICE,
		@ETC_QUANTITY,
		@ETC_VALUE,
		@ETC_TRADENO,
		@ETC_TRADETIME,
		@ETC_ACCRUEDINT,
		@ETC_YIELD,
		@ETC_PERIOD,
		@ETC_SETTLECODE,
		@ETC_BUYSELL,
		@ETC_REPORATE,
		@ETC_REPOVALUE,
		@ETC_REPO2VALUE,
		@ETC_REPOTERM
	)

GO

