if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[at_Issue]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[at_Issue]
GO

CREATE TABLE [dbo].[at_Issue] (
	[id] [numeric](10, 0) NOT NULL ,
	[name] [varchar] (7) NOT NULL ,
	[properties] [varchar] (255) NOT NULL ,
	[registration_number] [varchar] (31) NOT NULL ,
	[ISIN] [varchar] (12) NOT NULL ,
	[full_name] [varchar] (255) NULL ,
	[currency] [varchar] (3) NOT NULL ,
	[nominal] [numeric](16, 5) NOT NULL ,
	[price_currency] [varchar] (3) NOT NULL ,
	[settl_currency] [varchar] (3) NOT NULL ,
	[delivery_days] [tinyint] NOT NULL ,
	[total_amt] [numeric](16, 0) NOT NULL ,
	[type] [numeric](10, 0) NOT NULL ,
	[mode_trade] [numeric](10, 0) NOT NULL ,
	[issue_type] [tinyint] NOT NULL ,
	[pips] [tinyint] NOT NULL ,
	[end_ipo] [varchar] (17) NULL ,
	[z_ipo] [numeric](16, 5) NOT NULL ,
	[risk] [numeric](16, 5) NOT NULL ,
	[trade_on_off] [tinyint] NOT NULL ,
	[prec] [tinyint] NOT NULL ,
	[frac] [tinyint] NOT NULL ,
	[listlogdate] [varchar] (17) NULL ,
	[cutoffdate] [varchar] (17) NULL ,
	[create_moment] [varchar] (17) NULL ,
	[delete_moment] [varchar] (17) NULL ,
	[modify_moment] [varchar] (17) NULL ,
	[deleted] [char] (1) NOT NULL ,
	[depo_accounts] [varchar] (3) NOT NULL ,
	[lstg] [varchar] (7) NOT NULL ,
	[bid_best_price] [numeric](16, 5) NOT NULL ,
	[ask_best_price] [numeric](16, 5) NOT NULL ,
	[bid_inside_price] [numeric](16, 5) NOT NULL ,
	[bid_inside_size] [numeric](16, 0) NOT NULL ,
	[bid_changed] [varchar] (17) NULL ,
	[bid_change] [char] (1) NULL ,
	[bid_change_alert] [char] (1) NOT NULL ,
	[ask_inside_price] [numeric](16, 5) NOT NULL ,
	[ask_inside_size] [numeric](16, 0) NOT NULL ,
	[ask_changed] [varchar] (17) NULL ,
	[ask_change] [char] (1) NOT NULL ,
	[ask_change_alert] [char] (1) NOT NULL ,
	[trade_moment] [varchar] (17) NULL ,
	[trade_price] [numeric](16, 5) NOT NULL ,
	[trade_size] [numeric](16, 0) NOT NULL ,
	[trade_changed] [varchar] (17) NULL ,
	[trade_change] [char] (1) NOT NULL ,
	[trade_change_delta] [numeric](16, 5) NOT NULL ,
	[min_trade_price] [numeric](16, 5) NOT NULL ,
	[max_trade_price] [numeric](16, 5) NOT NULL ,
	[day_size] [numeric](16, 0) NOT NULL ,
	[day_vol] [numeric](26, 2) NOT NULL ,
	[open_price] [numeric](16, 5) NOT NULL ,
	[average_price] [numeric](16, 5) NOT NULL ,
	[previous_close] [numeric](16, 5) NOT NULL ,
	[market_price] [numeric](16, 5) NOT NULL ,
	[range] [numeric](3, 0) NULL ,
	[spread] [numeric](3, 0) NULL ,
	[aisle] [numeric](3, 0) NULL ,
	[aisle1] [numeric](3, 0) NULL ,
	[lot] [numeric](16, 0) NULL ,
	[lot_dbq] [numeric](16, 0) NULL ,
	[official_open] [numeric](16, 5) NULL ,
	[official_close] [numeric](16, 5) NULL ,
	[official_current] [numeric](16, 5) NULL ,
	[index_price] [numeric](16, 5) NULL ,
	[change_pct] [numeric](9, 2) NULL ,
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[at_Issue] WITH NOCHECK ADD 
	CONSTRAINT [PK_at_Issue] UNIQUE  NONCLUSTERED 
	(
		[id]
	)  ON [PRIMARY] 
GO

CREATE INDEX [at_Issue_I_Name_D] ON [dbo].[at_Issue]([name]) ON [PRIMARY]
GO

--------------------------------------------------------------------------------


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_atIssue]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_atIssue]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE    PROCEDURE sp_atIssue

@id numeric(10, 0) = NULL ,
@name varchar(7) = NULL,
@properties varchar(255) = NULL,
@registration_number varchar(31) = NULL,
@ISIN varchar(12) = NULL,
@full_name varchar(255) = NULL,
@currency varchar(3) = NULL,
@nominal numeric(16, 5) = NULL,
@price_currency varchar(3) = NULL,
@settl_currency varchar(3) = NULL,
@delivery_days tinyint = NULL,
@total_amt numeric(16, 0) = NULL,
@type numeric(10, 0) = NULL,
@mode_trade numeric(10, 0) = NULL,
@issue_type tinyint = NULL,
@pips tinyint = NULL,
@end_ipo varchar(17) = NULL,
@z_ipo numeric(16, 5) = NULL,
@risk numeric(16, 5) = NULL,
@trade_on_off tinyint = NULL,
@prec tinyint = NULL,
@frac tinyint = NULL,
@listlogdate varchar(17) = NULL,
@cutoffdate varchar(17) = NULL,
@create_moment varchar(17) = NULL,
@delete_moment varchar(17) = NULL,
@modify_moment varchar(17) = NULL,
@deleted char(1) = NULL,
@depo_accounts varchar (3) = NULL,
@lstg varchar (7) = NULL,
@bid_best_price numeric(16, 5) = NULL,
@ask_best_price numeric(16, 5) = NULL,
@bid_inside_price numeric(16, 5) = NULL,
@bid_inside_size numeric(16, 0) = NULL,
@bid_changed varchar(17) = NULL,
@bid_change char(1) = NULL,
@bid_change_alert char(1) = NULL,
@ask_inside_price numeric(16, 5) = NULL,
@ask_inside_size numeric(16, 0) = NULL,
@ask_changed varchar(17) = NULL,
@ask_change char(1) = NULL,
@ask_change_alert char(1) = NULL,
@trade_moment varchar(17) = NULL,
@trade_price numeric(16, 5) = NULL,
@trade_size numeric(16, 0) = NULL,
@trade_changed varchar(17) = NULL,
@trade_change char(1) = NULL,
@trade_change_delta numeric(16, 5) = NULL,
@min_trade_price numeric(16, 5) = NULL,
@max_trade_price numeric(16, 5) = NULL,
@day_size numeric(16, 0) = NULL,
@day_vol numeric(26, 2) = NULL,
@open_price numeric(16, 5) = NULL,
@average_price numeric(16, 5) = NULL,
@previous_close numeric(16, 5) = NULL, 
@market_price numeric(16, 5) = NULL, 
@range numeric(3, 0) = NULL, 
@spread numeric(3, 0) = NULL, 
@aisle numeric(3, 0) = NULL, 
@aisle1 numeric(3, 0) = NULL, 
@lot numeric(16, 0) = NULL, 
@lot_dbq numeric(16, 0) = NULL, 
@official_open numeric(16, 5) = NULL, 
@official_close numeric(16, 5) = NULL, 
@official_current numeric(16, 5) = NULL, 
@index_price numeric(16, 5) = NULL, 
@change_pct numeric(9, 2) = NULL 

AS

IF @id = NULL OR 
   @name = NULL OR 
   @properties = NULL OR 
   @registration_number = NULL OR
   @ISIN = NULL OR
   @full_name = NULL OR
   @currency = NULL OR
   @nominal = NULL OR
   @price_currency = NULL OR
   @settl_currency = NULL OR
   @delivery_days = NULL OR
   @total_amt = NULL OR
   @type = NULL OR
   @mode_trade = NULL OR
   @issue_type = NULL OR
   @pips = NULL OR
   @z_ipo = NULL OR
   @risk = NULL OR
   @trade_on_off = NULL OR
   @prec = NULL OR
   @frac = NULL OR
   @deleted = NULL OR
   @depo_accounts = NULL OR
   @lstg = NULL OR
   @bid_best_price = NULL OR
   @ask_best_price = NULL OR
   @bid_inside_price = NULL OR
   @bid_inside_size = NULL OR
   @bid_change = NULL OR
   @bid_change_alert = NULL OR
   @ask_inside_price = NULL OR
   @ask_inside_size = NULL OR
   @ask_change = NULL OR
   @ask_change_alert = NULL OR
   @trade_price = NULL OR
   @trade_size = NULL OR
   @trade_change = NULL OR
   @trade_change_delta = NULL OR
   @min_trade_price = NULL OR
   @max_trade_price = NULL OR
   @day_size = NULL OR
   @day_vol = NULL OR
   @open_price = NULL OR
   @average_price = NULL OR
   @previous_close = NULL OR
   @market_price = NULL OR
   @range = NULL OR
   @spread = NULL OR
   @aisle = NULL OR
   @aisle1 = NULL OR
   @lot = NULL OR
   @lot_dbq = NULL OR
   @official_open = NULL OR
   @official_close = NULL OR
   @official_current = NULL OR
   @index_price = NULL OR
   @change_pct = NULL 
	RETURN

if not exists (select * from dbo.sysobjects where id = object_id (N'[dbo].[at_Issue]') and OBJECTPROPERTY (id, N'IsUserTable') = 1)
	RETURN

IF EXISTS (SELECT * FROM at_Issue WHERE [id] = @id AND [name] = @name)
	UPDATE at_Issue SET
		[id]=@id,
		[name]=@name,
		properties=@properties,
		registration_number=@registration_number,
		ISIN=@ISIN,
		full_name=@full_name,
		currency=@currency,
		nominal=@nominal,
		price_currency=@price_currency,
		settl_currency=@settl_currency,
		delivery_days=@delivery_days,
		total_amt=@total_amt,
		[type]=@type,
		mode_trade=@mode_trade,
		issue_type=@issue_type,
		pips=@pips,
		end_ipo=@end_ipo,
		z_ipo=@z_ipo,
		risk=@risk,
		trade_on_off=@trade_on_off,
		prec=@prec,
		frac=@frac,
		listlogdate=@listlogdate,
		cutoffdate=@cutoffdate,
		create_moment=@create_moment,
		delete_moment=@delete_moment,
		modify_moment=@modify_moment,
		deleted=@deleted,
		depo_accounts=@depo_accounts,
		lstg=@lstg,
		bid_best_price=@bid_best_price,
		ask_best_price=@ask_best_price,
		bid_inside_price=@bid_inside_price,
		bid_inside_size=@bid_inside_size,
		bid_changed=@bid_changed,
		bid_change=@bid_change,
		bid_change_alert=@bid_change_alert,
		ask_inside_price=@ask_inside_price,
		ask_inside_size=@ask_inside_size,
		ask_changed=@ask_changed,
		ask_change=@ask_change,
		ask_change_alert=@ask_change_alert,
		trade_moment=@trade_moment,
		trade_price=@trade_price,
		trade_size=@trade_size,
		trade_changed=@trade_changed,
		trade_change=@trade_change,
		trade_change_delta=@trade_change_delta,
		min_trade_price=@min_trade_price,
		max_trade_price=@max_trade_price,
		day_size=@day_size,
		day_vol=@day_vol,
		open_price=@open_price,
		average_price=@average_price,
		previous_close=@previous_close,
		market_price=@market_price,
		range = @range,
		spread = @spread,
		aisle = @aisle,
		aisle1 = @aisle1,
		lot = @lot,
		lot_dbq = @lot_dbq,
		official_open = @official_open,
		official_close = @official_close,
		official_current = @official_current,
		index_price = @index_price,
		change_pct = @change_pct
	WHERE [id] = @id AND [name] = @name
ELSE
	INSERT INTO at_Issue
	(
		[id],
		[name],
		properties,
		registration_number,
		ISIN,
		full_name,
		currency,
		nominal,
		price_currency,
		settl_currency,
		delivery_days,
		total_amt,
		type,
		mode_trade,
		issue_type,
		pips,
		end_ipo,
		z_ipo,
		risk,
		trade_on_off,
		prec,
		frac,
		listlogdate,
		cutoffdate,
		create_moment,
		delete_moment,
		modify_moment,
		deleted,
		depo_accounts,
		lstg,
		bid_best_price,
		ask_best_price,
		bid_inside_price,
		bid_inside_size,
		bid_changed,
		bid_change,
		bid_change_alert,
		ask_inside_price,
		ask_inside_size,
		ask_changed,
		ask_change,
		ask_change_alert,
		trade_moment,
		trade_price,
		trade_size,
		trade_changed,
		trade_change,
		trade_change_delta,
		min_trade_price,
		max_trade_price,
		day_size,
		day_vol,
		open_price,
		average_price,
		previous_close,
		market_price,
		range,
		spread,
		aisle,
		aisle1,
		lot,
		lot_dbq,
		official_open,
		official_close,
		official_current,
		index_price,
		change_pct
	)
	VALUES
	(
		@id,
		@name,
		@properties,
		@registration_number,
		@ISIN,
		@full_name,
		@currency,
		@nominal,
		@price_currency,
		@settl_currency,
		@delivery_days,
		@total_amt,
		@type,
		@mode_trade,
		@issue_type,
		@pips,
		@end_ipo,
		@z_ipo,
		@risk,
		@trade_on_off,
		@prec,
		@frac,
		@listlogdate,
		@cutoffdate,
		@create_moment,
		@delete_moment,
		@modify_moment,
		@deleted,
		@depo_accounts,
		@lstg,
		@bid_best_price,
		@ask_best_price,
		@bid_inside_price,
		@bid_inside_size,
		@bid_changed,
		@bid_change,
		@bid_change_alert,
		@ask_inside_price,
		@ask_inside_size,
		@ask_changed,
		@ask_change,
		@ask_change_alert,
		@trade_moment,
		@trade_price,
		@trade_size,
		@trade_changed,
		@trade_change,
		@trade_change_delta,
		@min_trade_price,
		@max_trade_price,
		@day_size,
		@day_vol,
		@open_price,
		@average_price,
		@previous_close,
		@market_price,
		@range,
		@spread,
		@aisle,
		@aisle1,
		@lot,
		@lot_dbq,
		@official_open,
		@official_close,
		@official_current,
		@index_price,
		@change_pct
	)

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

