if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[at_MembersPositions]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[at_MembersPositions]
GO

CREATE TABLE [dbo].[at_MembersPositions] (
	[MEMBERID] [varchar] (12) NOT NULL ,
	[MEMBERNAME] [varchar] (50) NULL ,
	[CURRCODE] [varchar] (12) NOT NULL ,
	[TAG_SECCODE] [varchar] (12) NOT NULL ,
	[TAG_SECNAME] [varchar] (50) NULL ,
	[OPENBAL] [decimal](21, 4) NULL ,
	[CURRENTPOS] [decimal](21, 4) NULL ,
	[PLANNEDPOSBUY] [decimal](21, 4) NULL ,
	[PLANNEDPOSSELL] [decimal](21, 4) NULL ,
	[ORDERBUY] [decimal](21, 4) NULL ,
	[ORDERSELL] [decimal](21, 4) NULL ,
	[NETTO] [decimal](21, 4) NULL ,
	[LIMIT1] [decimal](21, 4) NULL ,
	[LIMIT2] [decimal](21, 4) NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[at_MembersPositions] ADD 
	CONSTRAINT [PK_at_MembersPositions] PRIMARY KEY  CLUSTERED 
	(
		[MEMBERID],
		[CURRCODE],
		[TAG_SECCODE]
	)  ON [PRIMARY] 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_atMembersPositions]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_atMembersPositions]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE   PROCEDURE sp_atMembersPositions
@MEMBERID varchar (12) = NULL,
@MEMBERNAME varchar (50) = NULL,
@CURRCODE varchar (12) = NULL,
@TAG_SECCODE varchar (12) = NULL,
@TAG_SECNAME varchar (50) = NULL,
@OPENBAL decimal(21,4) = NULL,
@CURRENTPOS decimal(21,4) = NULL,
@PLANNEDPOSBUY decimal(21,4) = NULL,
@PLANNEDPOSSELL decimal(21,4) = NULL,
@ORDERBUY decimal(21,4) = NULL,
@ORDERSELL decimal(21,4) = NULL,
@NETTO decimal(21,4) = NULL,
@LIMIT1 decimal(21,4) = NULL,
@LIMIT2 decimal(21,4) = NULL
AS

IF @MEMBERID = NULL OR @MEMBERID = '' OR @CURRCODE = NULL OR @CURRCODE = '' OR @TAG_SECCODE = NULL OR @TAG_SECCODE = ''
	RETURN

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[at_MembersPositions]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	RETURN

IF EXISTS (SELECT * FROM at_MembersPositions WHERE MEMBERID = @MEMBERID AND CURRCODE = @CURRCODE AND TAG_SECCODE = @TAG_SECCODE)
	UPDATE at_MembersPositions SET
		MEMBERNAME = @MEMBERNAME,
		TAG_SECNAME = @TAG_SECNAME,
		OPENBAL = @OPENBAL,
		CURRENTPOS = @CURRENTPOS,
		PLANNEDPOSBUY = @PLANNEDPOSBUY,
		PLANNEDPOSSELL = @PLANNEDPOSSELL,
		ORDERBUY = @ORDERBUY,
		ORDERSELL = @ORDERSELL,
		NETTO = @NETTO,
		LIMIT1 = @LIMIT1,
		LIMIT2 = @LIMIT2
	WHERE MEMBERID = @MEMBERID AND CURRCODE = @CURRCODE AND TAG_SECCODE = @TAG_SECCODE
ELSE
	INSERT INTO at_MembersPositions
	(
		MEMBERID,
		MEMBERNAME,
		CURRCODE,
		TAG_SECCODE,
		TAG_SECNAME,
		OPENBAL,
		CURRENTPOS,
		PLANNEDPOSBUY,
		PLANNEDPOSSELL,
		ORDERBUY,
		ORDERSELL,
		NETTO,
		LIMIT1,
		LIMIT2
	)
	VALUES
	(
		@MEMBERID,
		@MEMBERNAME,
		@CURRCODE,
		@TAG_SECCODE,
		@TAG_SECNAME,
		@OPENBAL,
		@CURRENTPOS,
		@PLANNEDPOSBUY,
		@PLANNEDPOSSELL,
		@ORDERBUY,
		@ORDERSELL,
		@NETTO,
		@LIMIT1,
		@LIMIT2
	)

GO

