if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[at_Orders]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[at_Orders]
GO

CREATE TABLE [dbo].[at_Orders] (
	[MEMBERID] [varchar] (5) NULL ,
	[ETC_ACCOUNT] [varchar] (12) NULL ,
	[ETC_SECBOARD] [varchar] (4) NULL ,
	[ETC_SECCODE] [varchar] (12) NULL ,
	[ETC_BUYSELL] [varchar] (1) NULL ,
	[ETC_ORDERNO] [numeric](10, 0) NOT NULL ,
	[ETC_BUY] [numeric](10, 0) NULL ,
	[ETC_PRICE] [float] NULL ,
	[ETC_SELL] [numeric](10, 0) NULL ,
	[ETC_ORDERTIME] [varchar] (8) NULL ,
	[ETC_STATUS] [varchar] (1) NULL ,
	[ETC_MKTLIMIT] [varchar] (1) NULL ,
	[ETC_IMMCANCEL] [varchar] (1) NULL ,
	[ETC_QUANTITY] [numeric](10, 0) NULL ,
	[ETC_VALUE] [float] NULL ,
	[ETC_ACCRUEDINT] [float] NULL ,
	[ETC_YIELD] [numeric](9, 2) NULL ,
	[ETC_PERIOD] [varchar] (1) NULL ,
	[ETC_PRICE2] [float] NULL ,
	[ETC_USERID] [varchar] (12) NULL ,
	[SUBBROKERID] [varchar] (5) NULL ,
	[ETC_BROKERREF] [varchar] (20) NULL,
	[ETC_MARKETMAKER] [varchar] (1) NULL,
	[ETC_SETTLECODE] [varchar] (12) NULL,
	[ETC_ACTIVATIONTIME] [varchar] (8) NULL,
	[ETC_WITHDRAWTIME] [varchar] (8) NULL,
	[ETC_HIDDEN] [numeric](10, 0) NULL
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[at_Orders] ADD 
	CONSTRAINT [PK_at_Orders] PRIMARY KEY  CLUSTERED 
	(
		[ETC_ORDERNO]
	)  ON [PRIMARY] 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_atOrders]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_atOrders]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE  PROCEDURE sp_atOrders
@MEMBERID varchar (5) = NULL,
@ETC_ACCOUNT varchar (12) = NULL,
@ETC_SECBOARD varchar (4) = NULL,
@ETC_SECCODE varchar (12) = NULL,
@ETC_BUYSELL varchar (1) = NULL,
@ETC_ORDERNO numeric(10, 0) = NULL,
@ETC_BUY numeric(10, 0) = NULL,
@ETC_PRICE float = NULL,
@ETC_SELL numeric(10, 0) = NULL,
@ETC_ORDERTIME varchar (8) = NULL,
@ETC_STATUS varchar (1) = NULL,
@ETC_MKTLIMIT varchar (1) = NULL,
@ETC_IMMCANCEL varchar (1) = NULL,
@ETC_QUANTITY numeric(10, 0) = NULL,
@ETC_VALUE float = NULL,
@ETC_ACCRUEDINT float = NULL,
@ETC_YIELD numeric(9, 2) = NULL,
@ETC_PERIOD varchar (1) = NULL,
@ETC_PRICE2 float = NULL,
@ETC_USERID varchar (12) = NULL,
@SUBBROKERID varchar (5) = NULL,
@ETC_BROKERREF varchar (20) = NULL,
@ETC_MARKETMAKER varchar (1) = NULL,
@ETC_SETTLECODE varchar (12) = NULL,
@ETC_ACTIVATIONTIME varchar (8) = NULL,
@ETC_WITHDRAWTIME varchar (8) = NULL,
@ETC_HIDDEN numeric(10, 0) = NULL
AS

IF @ETC_ORDERNO = NULL OR @ETC_ORDERNO = 0
	RETURN

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[at_Orders]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	RETURN

IF EXISTS (SELECT * FROM at_Orders WHERE ETC_ORDERNO = @ETC_ORDERNO)
	UPDATE at_Orders SET
		MEMBERID = @MEMBERID, 
		ETC_ACCOUNT = @ETC_ACCOUNT, 
		ETC_SECBOARD = @ETC_SECBOARD, 
		ETC_SECCODE = @ETC_SECCODE, 
		ETC_BUYSELL = @ETC_BUYSELL, 
		ETC_BUY = @ETC_BUY, 
		ETC_PRICE = @ETC_PRICE, 
		ETC_SELL = @ETC_SELL, 
		ETC_ORDERTIME = @ETC_ORDERTIME, 
		ETC_STATUS = @ETC_STATUS, 
		ETC_MKTLIMIT = @ETC_MKTLIMIT, 
		ETC_IMMCANCEL = @ETC_IMMCANCEL, 
		ETC_QUANTITY = @ETC_QUANTITY, 
		ETC_VALUE = @ETC_VALUE, 
		ETC_ACCRUEDINT = @ETC_ACCRUEDINT, 
		ETC_YIELD = @ETC_YIELD, 
		ETC_PERIOD = @ETC_PERIOD, 
		ETC_PRICE2 = @ETC_PRICE2, 
		ETC_USERID = @ETC_USERID, 
		SUBBROKERID = @SUBBROKERID, 
		ETC_BROKERREF = @ETC_BROKERREF,
		ETC_MARKETMAKER = @ETC_MARKETMAKER,
		ETC_SETTLECODE = @ETC_SETTLECODE,
		ETC_ACTIVATIONTIME = @ETC_ACTIVATIONTIME,
		ETC_WITHDRAWTIME = @ETC_WITHDRAWTIME,
		ETC_HIDDEN = @ETC_HIDDEN
	WHERE ETC_ORDERNO = @ETC_ORDERNO
ELSE
	INSERT INTO at_Orders
	(
		MEMBERID,
		ETC_ACCOUNT,
		ETC_SECBOARD,
		ETC_SECCODE,
		ETC_BUYSELL,
		ETC_ORDERNO,
		ETC_BUY,
		ETC_PRICE,
		ETC_SELL,
		ETC_ORDERTIME,
		ETC_STATUS,
		ETC_MKTLIMIT,
		ETC_IMMCANCEL,
		ETC_QUANTITY,
		ETC_VALUE,
		ETC_ACCRUEDINT,
		ETC_YIELD,
		ETC_PERIOD,
		ETC_PRICE2,
		ETC_USERID,
		SUBBROKERID,
		ETC_BROKERREF,
		ETC_MARKETMAKER,
		ETC_SETTLECODE,
		ETC_ACTIVATIONTIME,
		ETC_WITHDRAWTIME,
		ETC_HIDDEN
	)
	VALUES
	(
		@MEMBERID,
		@ETC_ACCOUNT,
		@ETC_SECBOARD,
		@ETC_SECCODE,
		@ETC_BUYSELL,
		@ETC_ORDERNO,
		@ETC_BUY,
		@ETC_PRICE,
		@ETC_SELL,
		@ETC_ORDERTIME,
		@ETC_STATUS,
		@ETC_MKTLIMIT,
		@ETC_IMMCANCEL,
		@ETC_QUANTITY,
		@ETC_VALUE,
		@ETC_ACCRUEDINT,
		@ETC_YIELD,
		@ETC_PERIOD,
		@ETC_PRICE2,
		@ETC_USERID,
		@SUBBROKERID,
		@ETC_BROKERREF,
		@ETC_MARKETMAKER,
		@ETC_SETTLECODE,
		@ETC_ACTIVATIONTIME,
		@ETC_WITHDRAWTIME,
		@ETC_HIDDEN
	)

GO
