if exists (select * from dbo.sysobjects where id = object_id(N'at_Securities') and OBJECTPROPERTY(id, N'IsUserTable') = 1)	
drop table at_Securities	

SET QUOTED_IDENTIFIER ON 	
GO	
SET ANSI_NULLS ON 	
GO	

CREATE TABLE at_Securities (	
	[etc_secboard] [char] (4) NOT NULL ,
	[etc_seccode] [char] (12) NOT NULL ,
	[etc_secname] [varchar] (30) NULL ,
	[etc_remarks] [varchar] (8) NULL ,
	[etc_shortname] [varchar] (10) NULL ,
	[etc_status] [varchar] (1) NULL ,
	[etc_tradingstatus] [varchar] (1) NULL ,
	[etc_marketcode] [varchar] (4) NULL ,
	[etc_lotsize] [numeric](8, 0) NULL ,
	[etc_minstep] [float] NULL ,
	[etc_facevalue] [numeric](16, 0) NULL ,
	[etc_faceunit] [varchar] (4) NULL ,
	[etc_prevdate] [varchar] (8) NULL ,
	[etc_prevprice] [float] NULL ,
	[etc_decimals] [numeric](2, 0) NULL ,
	[etc_yield] [numeric](9, 2) NULL ,
	[etc_accruedint] [float] NULL ,
	[etc_primarydist] [varchar] (1) NULL ,
	[etc_matdate] [varchar] (8) NULL ,
	[etc_couponvalue] [numeric](13, 2) NULL ,
	[etc_couponperiod] [varchar] (4) NULL ,
	[etc_nextcoupon] [varchar] (8) NULL ,
	[etc_issuesize] [numeric](16, 0) NULL ,
	[etc_prevwaprice] [float] NULL ,
	[etc_yieldatprevwaprice] [numeric](9, 2) NULL ,
	[etc_repo2price] [float] NULL ,
	[etc_bid] [float] NULL ,
	[etc_biddepth] [numeric](10, 0) NULL ,
	[etc_biddeptht] [numeric](10, 0) NULL ,
	[etc_numbids] [numeric](3, 0) NULL ,
	[etc_offer] [float] NULL ,
	[etc_offerdepth] [numeric](10, 0) NULL ,
	[etc_offerdeptht] [numeric](10, 0) NULL ,
	[etc_numoffers] [numeric](3, 0) NULL ,
	[etc_open] [float] NULL ,
	[etc_high] [float] NULL ,
	[etc_low] [float] NULL ,
	[etc_last] [float] NULL ,
	[etc_change] [float] NULL ,
	[change_pct] [numeric](9, 2) NULL ,
	[etc_qty] [numeric](10, 0) NULL ,
	[etc_time] [varchar] (6) NULL ,
	[etc_voltoday] [numeric](10, 0) NULL ,
	[etc_valtoday] [numeric](16, 0) NULL ,
	[etc_value] [float] NULL ,
	[etc_waprice] [float] NULL ,
	[etc_highbid] [float] NULL ,
	[etc_lowoffer] [float] NULL ,
	[etc_numtrades] [numeric](9, 0) NULL ,
	[etc_yieldatwaprice] [numeric](9, 2) NULL ,
	[etc_priceminusprevwaprice] [float] NULL ,
	[etc_closeprice] [float] NULL ,
	[etc_closeyield] [numeric](9, 2) NULL ,
	[etc_lastsettlecode] [varchar] (3) NULL ,
	[etc_marketprice] [float] NULL ,
	[etc_currencyid] [varchar] (4) NULL ,
	[etc_instrid] [varchar] (4) NULL ,
	[etc_buybackprice] [float] NULL ,
	[etc_buybackdate] [varchar] (8) NULL ,
	[etc_agentid] [varchar] (12) NULL ,
	[etc_quotebasis] [varchar] (1) NULL ,
	[etc_isin] [varchar] (12) NULL ,
	[etc_latname] [varchar] (30) NULL ,
	[etc_regnumber] [varchar] (20) NULL ,
	[etc_lastbid] [float] NULL ,
	[etc_lastoffer] [float] NULL ,
	[etc_marketpricetoday] [float] NULL ,
	[etc_duration] [numeric](7, 2) NULL ,
	[etc_settlecode] [varchar] (12) NULL ,
	[etc_lopenprice] [float] NULL ,
	[etc_lcurrentprice] [float] NULL ,
	[etc_lcloseprice] [float] NULL ,
	[etc_marketprice2] [float] NULL ,
	[etc_admittedquote] [float] NULL,
	[ETC_PREVLEGALCLOSEPRICE] [float] NULL,
	[ETC_PREVADMITTEDQUOTE] [float] NULL,
	[ETC_SECTYPE] [varchar] (1) NULL,
	[ETC_ACTIVATIONDATE] [varchar] (8) NULL,
	[ETC_PREVLOTSIZE] [numeric] (8,0) NULL,
	[ETC_LOTSIZECHANGEDATE] [varchar] (8) NULL,
	[ETC_OPENPERIODPRICE] [float] NULL,
	[ETC_COUNTERPRICE] [float] NULL,
	[ETC_MIN_CURR_LAST] [float] NULL,
	[MIN_CURR_LAST_TIME] [varchar] (8) NULL
) ON [PRIMARY]		
GO		

ALTER TABLE at_Securities WITH NOCHECK ADD 		
	CONSTRAINT PK_at_Securities PRIMARY KEY  CLUSTERED 	
	(	
		etc_secboard,
		etc_seccode
	)  ON [PRIMARY] 	
GO		

if exists (select * from dbo.sysobjects where id = object_id(N'sp_atSecurities') and OBJECTPROPERTY(id, N'IsProcedure') = 1)		
drop procedure sp_atSecurities		

SET QUOTED_IDENTIFIER ON 		
GO		
SET ANSI_NULLS ON 	
GO	

CREATE PROCEDURE sp_atSecurities	
	@etc_secboard char (4) = NULL   ,
	@etc_seccode char (12) = NULL   ,
	@etc_secname varchar (30) = NULL  ,
	@etc_remarks varchar (8) = NULL  ,
	@etc_shortname varchar (10) = NULL  ,
	@etc_status varchar (1) = NULL  ,
	@etc_tradingstatus varchar (1) = NULL  ,
	@etc_marketcode varchar (4) = NULL  ,
	@etc_lotsize numeric(8, 0) = NULL  ,
	@etc_minstep float = NULL  ,
	@etc_facevalue numeric(16, 0) = NULL  ,
	@etc_faceunit varchar (4) = NULL  ,
	@etc_prevdate varchar (8) = NULL  ,
	@etc_prevprice float = NULL  ,
	@etc_decimals numeric(2, 0) = NULL  ,
	@etc_yield numeric(9, 2) = NULL  ,
	@etc_accruedint float = NULL  ,
	@etc_primarydist varchar (1) = NULL  ,
	@etc_matdate varchar (8) = NULL  ,
	@etc_couponvalue numeric(13, 2) = NULL  ,
	@etc_couponperiod varchar (4) = NULL  ,
	@etc_nextcoupon varchar (8) = NULL  ,
	@etc_issuesize numeric(16, 0) = NULL  ,
	@etc_prevwaprice float = NULL  ,
	@etc_yieldatprevwaprice numeric(9, 2) = NULL  ,
	@etc_repo2price float = NULL  ,
	@etc_bid float = NULL  ,
	@etc_biddepth numeric(10, 0) = NULL  ,
	@etc_biddeptht numeric(10, 0) = NULL  ,
	@etc_numbids numeric(3, 0) = NULL  ,
	@etc_offer float = NULL  ,
	@etc_offerdepth numeric(10, 0) = NULL  ,
	@etc_offerdeptht numeric(10, 0) = NULL  ,
	@etc_numoffers numeric(3, 0) = NULL  ,
	@etc_open float = NULL  ,
	@etc_high float = NULL  ,
	@etc_low float = NULL  ,
	@etc_last float = NULL  ,
	@etc_change float = NULL  ,
	@change_pct numeric(9, 2) = NULL  ,
	@etc_qty numeric(10, 0) = NULL  ,
	@etc_time varchar (6) = NULL  ,
	@etc_voltoday numeric(10, 0) = NULL  ,
	@etc_valtoday numeric(16, 0) = NULL  ,
	@etc_value float = NULL  ,
	@etc_waprice float = NULL  ,
	@etc_highbid float = NULL  ,
	@etc_lowoffer float = NULL  ,
	@etc_numtrades numeric(9, 0) = NULL  ,
	@etc_yieldatwaprice numeric(9, 2) = NULL  ,
	@etc_priceminusprevwaprice float = NULL  ,
	@etc_closeprice float = NULL  ,
	@etc_closeyield numeric(9, 2) = NULL  ,
	@etc_lastsettlecode varchar (3) = NULL  ,
	@etc_marketprice float = NULL ,
	@etc_currencyid varchar (4) = NULL ,
	@etc_instrid varchar (4) = NULL ,
	@etc_buybackprice float = NULL ,
	@etc_buybackdate varchar (8) = NULL ,
	@etc_agentid varchar (12) = NULL ,
	@etc_quotebasis varchar (1) = NULL ,
	@etc_isin varchar (12) = NULL ,
	@etc_latname varchar (30) = NULL ,
	@etc_regnumber varchar (20) = NULL ,
	@etc_lastbid float = NULL ,
	@etc_lastoffer float = NULL ,
	@etc_marketpricetoday float = NULL ,
	@etc_duration numeric(7, 2) = NULL ,
	@etc_settlecode varchar (12) = NULL ,
	@etc_lopenprice float = NULL ,
	@etc_lcurrentprice float = NULL ,
	@etc_lcloseprice float = NULL ,
	@etc_marketprice2 float = NULL ,
	@etc_admittedquote float = NULL ,
	@ETC_PREVLEGALCLOSEPRICE float = NULL,
	@ETC_PREVADMITTEDQUOTE float = NULL,
	@ETC_SECTYPE varchar (1) = NULL,
	@ETC_ACTIVATIONDATE varchar (8) = NULL,
	@ETC_PREVLOTSIZE numeric (8,0) = NULL,
	@ETC_LOTSIZECHANGEDATE varchar (8) = NULL,
	@ETC_OPENPERIODPRICE float = NULL,
	@ETC_COUNTERPRICE float = NULL,
	@ETC_MIN_CURR_LAST float = NULL,
	@MIN_CURR_LAST_TIME varchar (8) = NULL
AS	

IF @etc_secboard = NULL OR @etc_secboard = '' OR @etc_seccode = NULL OR @etc_seccode = ''	
	RETURN

if not exists (select * from dbo.sysobjects where id = object_id (N'[dbo].[at_Securities]') and OBJECTPROPERTY (id, N'IsUserTable') = 1)		
	RETURN	

IF EXISTS (SELECT * FROM at_Securities WHERE etc_secboard = @etc_secboard AND etc_seccode = @etc_seccode)		

	UPDATE at_Securities SET	
		etc_secname = @etc_secname , 
		etc_remarks = @etc_remarks , 
		etc_shortname = @etc_shortname , 
		etc_status = @etc_status , 
		etc_tradingstatus = @etc_tradingstatus , 
		etc_marketcode = @etc_marketcode , 
		etc_lotsize = @etc_lotsize , 
		etc_minstep = @etc_minstep , 
		etc_facevalue = @etc_facevalue , 
		etc_faceunit = @etc_faceunit , 
		etc_prevdate = @etc_prevdate , 
		etc_prevprice = @etc_prevprice , 
		etc_decimals = @etc_decimals , 
		etc_yield = @etc_yield , 
		etc_accruedint = @etc_accruedint , 
		etc_primarydist = @etc_primarydist , 
		etc_matdate = @etc_matdate , 
		etc_couponvalue = @etc_couponvalue , 
		etc_couponperiod = @etc_couponperiod , 
		etc_nextcoupon = @etc_nextcoupon , 
		etc_issuesize = @etc_issuesize , 
		etc_prevwaprice = @etc_prevwaprice , 
		etc_yieldatprevwaprice = @etc_yieldatprevwaprice , 
		etc_repo2price = @etc_repo2price , 
		etc_bid = @etc_bid , 
		etc_biddepth = @etc_biddepth , 
		etc_biddeptht = @etc_biddeptht , 
		etc_numbids = @etc_numbids , 
		etc_offer = @etc_offer , 
		etc_offerdepth = @etc_offerdepth , 
		etc_offerdeptht = @etc_offerdeptht , 
		etc_numoffers = @etc_numoffers , 
		etc_open = @etc_open , 
		etc_high = @etc_high , 
		etc_low = @etc_low , 
		etc_last = @etc_last , 
		etc_change = @etc_change , 
		change_pct = @change_pct , 
		etc_qty = @etc_qty , 
		etc_time = @etc_time , 
		etc_voltoday = @etc_voltoday , 
		etc_valtoday = @etc_valtoday , 
		etc_value = @etc_value , 
		etc_waprice = @etc_waprice , 
		etc_highbid = @etc_highbid , 
		etc_lowoffer = @etc_lowoffer , 
		etc_numtrades = @etc_numtrades , 
		etc_yieldatwaprice = @etc_yieldatwaprice , 
		etc_priceminusprevwaprice = @etc_priceminusprevwaprice , 
		etc_closeprice = @etc_closeprice , 
		etc_closeyield = @etc_closeyield , 
		etc_lastsettlecode = @etc_lastsettlecode , 
		etc_marketprice = @etc_marketprice ,
		etc_currencyid = @etc_currencyid ,
		etc_instrid = @etc_instrid ,
		etc_buybackprice = @etc_buybackprice ,
		etc_buybackdate = @etc_buybackdate ,
		etc_agentid = @etc_agentid ,
		etc_quotebasis = @etc_quotebasis ,
		etc_isin = @etc_isin ,
		etc_latname = @etc_latname ,
		etc_regnumber = @etc_regnumber ,
		etc_lastbid = @etc_lastbid ,
		etc_lastoffer = @etc_lastoffer ,
		etc_marketpricetoday = @etc_marketpricetoday ,
		etc_duration = @etc_duration ,
		etc_settlecode = @etc_settlecode ,
		etc_lopenprice = @etc_lopenprice ,
		etc_lcurrentprice = @etc_lcurrentprice ,
		etc_lcloseprice = @etc_lcloseprice ,
		etc_marketprice2 = @etc_marketprice2 ,
		etc_admittedquote = @etc_admittedquote ,
		ETC_PREVLEGALCLOSEPRICE = @ETC_PREVLEGALCLOSEPRICE,
		ETC_PREVADMITTEDQUOTE = @ETC_PREVADMITTEDQUOTE,
		ETC_SECTYPE = @ETC_SECTYPE,
		ETC_ACTIVATIONDATE = @ETC_ACTIVATIONDATE,
		ETC_PREVLOTSIZE = @ETC_PREVLOTSIZE,
		ETC_LOTSIZECHANGEDATE = @ETC_LOTSIZECHANGEDATE,
		ETC_OPENPERIODPRICE = @ETC_OPENPERIODPRICE,
		ETC_COUNTERPRICE = @ETC_COUNTERPRICE,
		ETC_MIN_CURR_LAST = @ETC_MIN_CURR_LAST,
		MIN_CURR_LAST_TIME = @MIN_CURR_LAST_TIME
	WHERE etc_secboard = @etc_secboard AND etc_seccode = @etc_seccode	
ELSE		
	INSERT INTO at_Securities	
	(	
		etc_secboard , 
		etc_seccode , 
		etc_secname , 
		etc_remarks , 
		etc_shortname , 
		etc_status , 
		etc_tradingstatus , 
		etc_marketcode , 
		etc_lotsize , 
		etc_minstep , 
		etc_facevalue , 
		etc_faceunit , 
		etc_prevdate , 
		etc_prevprice , 
		etc_decimals , 
		etc_yield , 
		etc_accruedint , 
		etc_primarydist , 
		etc_matdate , 
		etc_couponvalue , 
		etc_couponperiod , 
		etc_nextcoupon , 
		etc_issuesize , 
		etc_prevwaprice , 
		etc_yieldatprevwaprice , 
		etc_repo2price , 
		etc_bid , 
		etc_biddepth , 
		etc_biddeptht , 
		etc_numbids , 
		etc_offer , 
		etc_offerdepth , 
		etc_offerdeptht , 
		etc_numoffers , 
		etc_open , 
		etc_high , 
		etc_low , 
		etc_last , 
		etc_change , 
		change_pct , 
		etc_qty , 
		etc_time , 
		etc_voltoday , 
		etc_valtoday , 
		etc_value , 
		etc_waprice , 
		etc_highbid , 
		etc_lowoffer , 
		etc_numtrades , 
		etc_yieldatwaprice , 
		etc_priceminusprevwaprice , 
		etc_closeprice , 
		etc_closeyield , 
		etc_lastsettlecode , 
		etc_marketprice ,
		etc_currencyid ,
		etc_instrid ,
		etc_buybackprice ,
		etc_buybackdate ,
		etc_agentid ,
		etc_quotebasis ,
		etc_isin ,
		etc_latname ,
		etc_regnumber ,
		etc_lastbid ,
		etc_lastoffer ,
		etc_marketpricetoday ,
		etc_duration ,
		etc_settlecode ,
		etc_lopenprice ,
		etc_lcurrentprice ,
		etc_lcloseprice ,
		etc_marketprice2 ,
		etc_admittedquote ,
		ETC_PREVLEGALCLOSEPRICE,
		ETC_PREVADMITTEDQUOTE,
		ETC_SECTYPE,
		ETC_ACTIVATIONDATE,
		ETC_PREVLOTSIZE,
		ETC_LOTSIZECHANGEDATE,
		ETC_OPENPERIODPRICE,
		ETC_COUNTERPRICE,
		ETC_MIN_CURR_LAST,
		MIN_CURR_LAST_TIME
	)	
	VALUES	
	 (	
		@etc_secboard , 
		@etc_seccode , 
		@etc_secname , 
		@etc_remarks , 
		@etc_shortname , 
		@etc_status , 
		@etc_tradingstatus , 
		@etc_marketcode , 
		@etc_lotsize , 
		@etc_minstep , 
		@etc_facevalue , 
		@etc_faceunit , 
		@etc_prevdate , 
		@etc_prevprice , 
		@etc_decimals , 
		@etc_yield , 
		@etc_accruedint , 
		@etc_primarydist , 
		@etc_matdate , 
		@etc_couponvalue , 
		@etc_couponperiod , 
		@etc_nextcoupon , 
		@etc_issuesize , 
		@etc_prevwaprice , 
		@etc_yieldatprevwaprice , 
		@etc_repo2price , 
		@etc_bid , 
		@etc_biddepth , 
		@etc_biddeptht , 
		@etc_numbids , 
		@etc_offer , 
		@etc_offerdepth , 
		@etc_offerdeptht , 
		@etc_numoffers , 
		@etc_open , 
		@etc_high , 
		@etc_low , 
		@etc_last , 
		@etc_change , 
		@change_pct , 
		@etc_qty , 
		@etc_time , 
		@etc_voltoday , 
		@etc_valtoday , 
		@etc_value , 
		@etc_waprice , 
		@etc_highbid , 
		@etc_lowoffer , 
		@etc_numtrades , 
		@etc_yieldatwaprice , 
		@etc_priceminusprevwaprice , 
		@etc_closeprice , 
		@etc_closeyield , 
		@etc_lastsettlecode , 
		@etc_marketprice ,
		@etc_currencyid ,
		@etc_instrid ,
		@etc_buybackprice ,
		@etc_buybackdate ,
		@etc_agentid ,
		@etc_quotebasis ,
		@etc_isin ,
		@etc_latname ,
		@etc_regnumber ,
		@etc_lastbid ,
		@etc_lastoffer ,
		@etc_marketpricetoday ,
		@etc_duration ,
		@etc_settlecode ,
		@etc_lopenprice ,
		@etc_lcurrentprice ,
		@etc_lcloseprice ,
		@etc_marketprice2 ,
		@etc_admittedquote ,
		@ETC_PREVLEGALCLOSEPRICE,
		@ETC_PREVADMITTEDQUOTE,
		@ETC_SECTYPE,
		@ETC_ACTIVATIONDATE,
		@ETC_PREVLOTSIZE,
		@ETC_LOTSIZECHANGEDATE,
		@ETC_OPENPERIODPRICE,
		@ETC_COUNTERPRICE,
		@ETC_MIN_CURR_LAST,
		@MIN_CURR_LAST_TIME
	)	

GO		
SET QUOTED_IDENTIFIER OFF 		
GO		
SET ANSI_NULLS ON 		
GO		
		
		
		
		
		
		
		
		
		
