if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[at_Trades]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[at_Trades]
GO

CREATE TABLE [dbo].[at_Trades] (
	[MEMBERID] [varchar] (5) NULL ,
	[ETC_ACCOUNT] [varchar] (12) NULL ,
	[ETC_SECBOARD] [varchar] (4) NULL ,
	[ETC_SECCODE] [varchar] (12) NULL ,
	[ETC_TRADENO] [numeric](10, 0) NOT NULL ,
	[ETC_BUYSELL] [varchar] (1) NOT NULL ,
	[ETC_BUY] [numeric](10, 0) NULL ,
	[ETC_PRICE] [float] NULL ,
	[ETC_SELL] [numeric](10, 0) NULL ,
	[ETC_VALUE] [float] NULL ,
	[ETC_SETTLEDATE] [varchar] (8) NULL ,
	[ETC_ACCRUEDINT] [float] NULL ,
	[ETC_YIELD] [numeric](9, 2) NULL ,
	[ETC_PERIOD] [varchar] (1) NULL ,
	[ETC_PRICE2] [float] NULL ,
	[ETC_SETTLECODE] [varchar] (3) NULL ,
	[ETC_TRADETYPE] [varchar] (1) NULL ,
	[ETC_COMMISSION] [numeric](16, 2) NULL ,
	[ETC_REPORATE] [numeric](9, 2) NULL ,
	[ETC_ORDERNO] [numeric](10, 0) NULL ,
	[ETC_TRADETIME] [varchar] (8) NULL ,
	[ETC_USERID] [varchar] (12) NULL ,
	[SUBBROKERID] [varchar] (5) NULL ,
	[ETC_BROKERREF] [varchar] (20) NULL,
	[ETC_ACCRUED2] [float] NULL,
	[ETC_REPOVALUE] [float] NULL,
	[ETC_REPO2VALUE] [float] NULL,
	[ETC_REPOTERM] [numeric] (8,0) NULL,
	[ETC_STARTDISCOUNT] [float] NULL,
	[ETC_LOWERDISCOUNT] [float] NULL,
	[ETC_UPPERDISCOUNT] [float] NULL,
	[ETC_BLOCKSECURITIES] [varchar] (1) NULL,
	[ETC_CLEARINGCENTERCOMM] [float] NULL,
	[ETC_EXCHANGECOMM] [float] NULL,
	[ETC_TRADINGSYSTEMCOMM] [float] NULL,
	[ETC_CPFIRMID] [varchar] (12) NULL
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[at_Trades] ADD 
	CONSTRAINT [PK_at_Trades] PRIMARY KEY  CLUSTERED 
	(
		[ETC_TRADENO],
		[ETC_BUYSELL]
	)  ON [PRIMARY] 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_atTrades]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_atTrades]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE  PROCEDURE sp_atTrades
@MEMBERID varchar (5) = NULL,
@ETC_ACCOUNT varchar (12) = NULL,
@ETC_SECBOARD varchar (4) = NULL,
@ETC_SECCODE varchar (12) = NULL,
@ETC_TRADENO numeric (10, 0) = NULL,
@ETC_BUYSELL varchar (1) = NULL,
@ETC_BUY numeric (10, 0) = NULL,
@ETC_PRICE float = NULL,
@ETC_SELL numeric (10, 0) = NULL,
@ETC_VALUE float = NULL,
@ETC_SETTLEDATE varchar (8) = NULL,
@ETC_ACCRUEDINT float = NULL,
@ETC_YIELD numeric (9, 2) = NULL,
@ETC_PERIOD varchar (1) = NULL,
@ETC_PRICE2 float = NULL,
@ETC_SETTLECODE varchar (3) = NULL,
@ETC_TRADETYPE varchar (1) = NULL,
@ETC_COMMISSION numeric (16, 2) = NULL,
@ETC_REPORATE numeric (9, 2) = NULL,
@ETC_ORDERNO numeric (10, 0) = NULL,
@ETC_TRADETIME varchar (8) = NULL,
@ETC_USERID varchar (12) = NULL,
@SUBBROKERID varchar (5) = NULL,
@ETC_BROKERREF varchar (20) = NULL,
@ETC_ACCRUED2 float = NULL,
@ETC_REPOVALUE float = NULL,
@ETC_REPO2VALUE float = NULL,
@ETC_REPOTERM numeric (8,0) = NULL,
@ETC_STARTDISCOUNT float = NULL,
@ETC_LOWERDISCOUNT float = NULL,
@ETC_UPPERDISCOUNT float = NULL,
@ETC_BLOCKSECURITIES varchar (1) = NULL,
@ETC_CLEARINGCENTERCOMM float = NULL,
@ETC_EXCHANGECOMM float = NULL,
@ETC_TRADINGSYSTEMCOMM float = NULL,
@ETC_CPFIRMID varchar (12) = NULL
AS

IF @ETC_TRADENO = NULL OR @ETC_TRADENO = 0 OR @ETC_BUYSELL = NULL OR @ETC_BUYSELL = ''
	RETURN

if not exists (select * from dbo.sysobjects where id = object_id (N'[dbo].[at_Trades]') and OBJECTPROPERTY (id, N'IsUserTable') = 1)
	RETURN

IF EXISTS (SELECT * FROM at_Trades WHERE ETC_TRADENO = @ETC_TRADENO AND ETC_BUYSELL = @ETC_BUYSELL)
	UPDATE at_Trades SET
		MEMBERID = @MEMBERID,
		ETC_ACCOUNT = @ETC_ACCOUNT,
		ETC_SECBOARD = @ETC_SECBOARD,
		ETC_SECCODE = @ETC_SECCODE,
		ETC_BUY = @ETC_BUY,
		ETC_PRICE = @ETC_PRICE,
		ETC_SELL = @ETC_SELL,
		ETC_VALUE = @ETC_VALUE,
		ETC_SETTLEDATE = @ETC_SETTLEDATE,
		ETC_ACCRUEDINT = @ETC_ACCRUEDINT,
		ETC_YIELD = @ETC_YIELD,
		ETC_PERIOD = @ETC_PERIOD,
		ETC_PRICE2 = @ETC_PRICE2,
		ETC_SETTLECODE = @ETC_SETTLECODE,
		ETC_TRADETYPE = @ETC_TRADETYPE,
		ETC_COMMISSION = @ETC_COMMISSION,
		ETC_REPORATE = @ETC_REPORATE,
		ETC_ORDERNO = @ETC_ORDERNO,
		ETC_TRADETIME = @ETC_TRADETIME,
		ETC_USERID = @ETC_USERID,
		SUBBROKERID = @SUBBROKERID,
		ETC_BROKERREF = @ETC_BROKERREF,
		ETC_ACCRUED2 = @ETC_ACCRUED2,
		ETC_REPOVALUE = @ETC_REPOVALUE,
		ETC_REPO2VALUE = @ETC_REPO2VALUE,
		ETC_REPOTERM = @ETC_REPOTERM,
		ETC_STARTDISCOUNT = @ETC_STARTDISCOUNT,
		ETC_LOWERDISCOUNT = @ETC_LOWERDISCOUNT,
		ETC_UPPERDISCOUNT = @ETC_UPPERDISCOUNT,
		ETC_BLOCKSECURITIES = @ETC_BLOCKSECURITIES,
		ETC_CLEARINGCENTERCOMM = @ETC_CLEARINGCENTERCOMM,
		ETC_EXCHANGECOMM = @ETC_EXCHANGECOMM,
		ETC_TRADINGSYSTEMCOMM = @ETC_TRADINGSYSTEMCOMM,
		ETC_CPFIRMID = @ETC_CPFIRMID
	WHERE ETC_TRADENO = @ETC_TRADENO AND ETC_BUYSELL = @ETC_BUYSELL
ELSE
	INSERT INTO at_Trades
	 (
		MEMBERID,
		ETC_ACCOUNT,
		ETC_SECBOARD,
		ETC_SECCODE,
		ETC_TRADENO,
		ETC_BUYSELL,
		ETC_BUY,
		ETC_PRICE,
		ETC_SELL,
		ETC_VALUE,
		ETC_SETTLEDATE,
		ETC_ACCRUEDINT,
		ETC_YIELD,
		ETC_PERIOD,
		ETC_PRICE2,
		ETC_SETTLECODE,
		ETC_TRADETYPE,
		ETC_COMMISSION,
		ETC_REPORATE,
		ETC_ORDERNO,
		ETC_TRADETIME,
		ETC_USERID,
		SUBBROKERID,
		ETC_BROKERREF,
		ETC_ACCRUED2,
		ETC_REPOVALUE,
		ETC_REPO2VALUE,
		ETC_REPOTERM,
		ETC_STARTDISCOUNT,
		ETC_LOWERDISCOUNT,
		ETC_UPPERDISCOUNT,
		ETC_BLOCKSECURITIES,
		ETC_CLEARINGCENTERCOMM,
		ETC_EXCHANGECOMM,
		ETC_TRADINGSYSTEMCOMM,
		ETC_CPFIRMID
	)
	VALUES
	 (
		@MEMBERID,
		@ETC_ACCOUNT,
		@ETC_SECBOARD,
		@ETC_SECCODE,
		@ETC_TRADENO,
		@ETC_BUYSELL,
		@ETC_BUY,
		@ETC_PRICE,
		@ETC_SELL,
		@ETC_VALUE,
		@ETC_SETTLEDATE,
		@ETC_ACCRUEDINT,
		@ETC_YIELD,
		@ETC_PERIOD,
		@ETC_PRICE2,
		@ETC_SETTLECODE,
		@ETC_TRADETYPE,
		@ETC_COMMISSION,
		@ETC_REPORATE,
		@ETC_ORDERNO,
		@ETC_TRADETIME,
		@ETC_USERID,
		@SUBBROKERID,
		@ETC_BROKERREF,
		@ETC_ACCRUED2,
		@ETC_REPOVALUE,
		@ETC_REPO2VALUE,
		@ETC_REPOTERM,
		@ETC_STARTDISCOUNT,
		@ETC_LOWERDISCOUNT,
		@ETC_UPPERDISCOUNT,
		@ETC_BLOCKSECURITIES,
		@ETC_CLEARINGCENTERCOMM,
		@ETC_EXCHANGECOMM,
		@ETC_TRADINGSYSTEMCOMM,
		@ETC_CPFIRMID
   )

GO

